import os,re,gzip,math,struct
import sys

def laplace(n,nei,totWei,sigma):
	if totWei >0:
		lx = n[0] - sum([s[0][0]*math.exp(-(s[1]*s[1])/(sigma**2)) for s in nei])/totWei
		ly = n[1] - sum([s[0][1]*math.exp(-(s[1]*s[1])/(sigma**2)) for s in nei])/totWei
		lz = n[2] - sum([s[0][2]*math.exp(-(s[1]*s[1])/(sigma**2)) for s in nei])/totWei
		return math.sqrt(lx**2 + ly**2 + lz**2)
	else:
		return 0

if len(sys.argv) < 4:
	print 'Error, this script takes at least 3 arguments: the directory where pdb files are stored, the name of the output file for the database and one or more sigma value.'
	sys.exit()
else:
	sigmas = []
	for sigma in sys.argv[3:]:
		sigmas.append(float(sigma))
	out = open(sys.argv[2]+'.lna','wb')
	cpt = 0
	cpt2 = 0
	totLen = 0
	seqs = [] 
	for root,dirs,files in os.walk(sys.argv[1]):
		for fil in files:
			print root,fil
			spli = open(root+'/'+fil).read().split('\n')
			cpt2 += 1
			chains = {}
			done = []
			currNum = ''
			for line in spli:
				if line[0:3]=='TER':
					done.append(lastKey)
				if line[13:15] == 'CA' and (line[:4] == 'ATOM' or line[:6] == 'HETATM') and line[22:26] != currNum and line[21:22] not in done:
					if not line[21:22] in chains.keys():
						chains[line[21:22]] = []
					chains[line[21:22]].append(line[30:54])
					currNum = line[22:26]
					lastKey = line[21:22]
			for key in chains.keys()[:1]:
				cpt += 1
				dists = []
				for i in range(0,len(chains[key])):
					try:
						dists.append((float(chains[key][i][0:8]),float(chains[key][i][8:16]),float(chains[key][i][16:])))
					except:
						print 'error: ',chains[key][i]
			
				seq = []
				for i in range(0,len(dists)):
					seq2 = []
					totWei = []
					for sigma in sigmas:
						totWei.append(0)
					for j in range(0,len(dists)):
						if abs(i-j)>1:
							d = math.sqrt((dists[i][0]-dists[j][0])**2+(dists[i][1]-dists[j][1])**2+(dists[i][2]-dists[j][2])**2)
							seq2.append((dists[j],d))
							for s in range(0,len(sigmas)):
								totWei[s] += math.exp(-(d*d)/(sigmas[s]**2))
					for s in range(0,len(sigmas)):
						seq.append(laplace(dists[i],seq2,totWei[s],sigmas[s]))
						print seq[-1],
				totLen += len(seq)
				seqs.append(seq)

	print len(sigmas),totLen,len(seqs)
	out.write(struct.pack('I',len(sigmas)))
	out.write(struct.pack('I',totLen))
	out.write(struct.pack('I',len(seqs)))
	for seq in seqs:
		out.write(struct.pack('I',len(seq)/len(sigmas)))
	for seq in seqs:
		for v in seq:
			out.write(struct.pack('f',v))
	print(cpt,'files containing ',cpt2,' sequences indexed, total length is ',totLen)
